
# 3.1.0

Release date: `2018-05-23`

Changes in command line arguments:

- Added `access-online`
- Renamed `share-link` -> `copy-share-link`
- Renamed `metadata` -> `edit-metadata`

## Core

- [NXDRIVE-626](https://jira.nuxeo.com/browse/NXDRIVE-626): Use Crowdin for label translations
- [NXDRIVE-925](https://jira.nuxeo.com/browse/NXDRIVE-925): Conflict resolve using local is not working
- [NXDRIVE-988](https://jira.nuxeo.com/browse/NXDRIVE-988): Handle local document deletion and restore on macOS
- [NXDRIVE-1121](https://jira.nuxeo.com/browse/NXDRIVE-1121): Set modified date to Nuxeo platform modified date
- [NXDRIVE-1130](https://jira.nuxeo.com/browse/NXDRIVE-1130): Set creation date to Nuxeo platform creation date
- [NXDRIVE-1132](https://jira.nuxeo.com/browse/NXDRIVE-1132): Security fix in the Crypto module (move to PyCryptodome)
- [NXDRIVE-1133](https://jira.nuxeo.com/browse/NXDRIVE-1133): Purge dead code reported by the 'vulture' tool
- [NXDRIVE-1143](https://jira.nuxeo.com/browse/NXDRIVE-1143): New auto-update framework (**breaking change**)
- [NXDRIVE-1147](https://jira.nuxeo.com/browse/NXDRIVE-1147): Do not definitively delete a document synced elsewhere
- [NXDRIVE-1152](https://jira.nuxeo.com/browse/NXDRIVE-1152): Handle document delete operation by server version
- [NXDRIVE-1154](https://jira.nuxeo.com/browse/NXDRIVE-1154): Persist the server's UI into the local configuration database
- [NXDRIVE-1163](https://jira.nuxeo.com/browse/NXDRIVE-1163): Direct Edit does not work with filenames containing spaces
- [NXDRIVE-1174](https://jira.nuxeo.com/browse/NXDRIVE-1174): Efficient `ConfigurationDAO.update_config()`
- [NXDRIVE-1207](https://jira.nuxeo.com/browse/NXDRIVE-1207): Modifying a file overwrites event on its parent folder
- [NXDRIVE-1327](https://jira.nuxeo.com/browse/NXDRIVE-1327): Add the is_frozen decorator

## GUI

- [NXDRIVE-289](https://jira.nuxeo.com/browse/NXDRIVE-289): Use light icons on Windows
- [NXDRIVE-715](https://jira.nuxeo.com/browse/NXDRIVE-715): Use SVG for icons
- [NXDRIVE-891](https://jira.nuxeo.com/browse/NXDRIVE-891): Locked notification displays 'userid' instead of full username
- [NXDRIVE-1025](https://jira.nuxeo.com/browse/NXDRIVE-1025): Filters issue with folders at the same tree level
- [NXDRIVE-1108](https://jira.nuxeo.com/browse/NXDRIVE-1108): Standardize and rename context menu entry
- [NXDRIVE-1123](https://jira.nuxeo.com/browse/NXDRIVE-1123): Access right-click action on folders on Windows
- [NXDRIVE-1124](https://jira.nuxeo.com/browse/NXDRIVE-1124): Right click menu entry on files: "Copy share-link"
- [NXDRIVE-1126](https://jira.nuxeo.com/browse/NXDRIVE-1126): Notifications are size limited
- [NXDRIVE-1136](https://jira.nuxeo.com/browse/NXDRIVE-1136): Change systray icon on update
- [NXDRIVE-1140](https://jira.nuxeo.com/browse/NXDRIVE-1140): Use a GIF for the transferring icon
- [NXDRIVE-1149](https://jira.nuxeo.com/browse/NXDRIVE-1149): New language: Indonesian
- [NXDRIVE-1157](https://jira.nuxeo.com/browse/NXDRIVE-1157): Use file system decoration on macOS
- [NXDRIVE-1158](https://jira.nuxeo.com/browse/NXDRIVE-1158): Restore the context menu "Edit metadata"
- [NXDRIVE-1166](https://jira.nuxeo.com/browse/NXDRIVE-1166): Display a notification on new update on GNU/Linux
- [NXDRIVE-1175](https://jira.nuxeo.com/browse/NXDRIVE-1175): New language: Hebrew
- [NXDRIVE-1193](https://jira.nuxeo.com/browse/NXDRIVE-1193): Switch all HTML messages box to simple Qt box
- [NXDRIVE-1375](https://jira.nuxeo.com/browse/NXDRIVE-1375): Better wording when the user is not signed in and using Direct Edit

## Packaging / Build

- [NXDRIVE-136](https://jira.nuxeo.com/browse/NXDRIVE-136): Activate code signing on macOS (valid until 2023-03-10)
- [NXDRIVE-261](https://jira.nuxeo.com/browse/NXDRIVE-261): Activate code signing on Windows (valid until 2021-04-25)
- [NXDRIVE-448](https://jira.nuxeo.com/browse/NXDRIVE-448): Fix version displayed in Windows uninstall
- [NXDRIVE-512](https://jira.nuxeo.com/browse/NXDRIVE-512): Windows application properties not set
- [NXDRIVE-601](https://jira.nuxeo.com/browse/NXDRIVE-601): Provide a user installation mode on Windows
- [NXDRIVE-730](https://jira.nuxeo.com/browse/NXDRIVE-730): Move to PyInstaller (**breaking change**)
- [NXDRIVE-1125](https://jira.nuxeo.com/browse/NXDRIVE-1125): Make Finder interactions through FinderSync extension on macOS
- [NXDRIVE-1146](https://jira.nuxeo.com/browse/NXDRIVE-1146): Drop module availability on PyPi
- [NXDRIVE-1162](https://jira.nuxeo.com/browse/NXDRIVE-1162): Update deploy scripts according to the new auto-update framework
- [NXDRIVE-1187](https://jira.nuxeo.com/browse/NXDRIVE-1187): Fix the PowerShell download command for Windows packaging
- [NXDRIVE-1202](https://jira.nuxeo.com/browse/NXDRIVE-1202): Upgrade to Python 2.7.15

## Tests

- [NXDRIVE-1078](https://jira.nuxeo.com/browse/NXDRIVE-1078): Create a pytest plugin for random bugs
- [NXDRIVE-1173](https://jira.nuxeo.com/browse/NXDRIVE-1173): Fix pip installation on Windows
- [NXDRIVE-1191](https://jira.nuxeo.com/browse/NXDRIVE-1191): Use Java OpenJDK instead of Java Oracle

## Minor Changes

- Auto-update: automatically install a new update if no bound engine
- CLI: Removed `--stop-on-error` argument
- Doc: Removed the "Microsoft Visual C++ Compiler for Python 2.7" requirement
- Framework: Use ecm:isVersion instead of ecm:isCheckedInVersion
- Jenkins: Possibility to launch the beta job on a given branch
- Jenkins: Possibility to launch the release job on a given beta version
- Jenkins: Update the Nuxeo snapshot to 10.2
- Packaging: Fix symlink creation in `deploy.sh`
- Packaging: Merged OS specific requirements-*.txt into one file
- Packaging: Added `pyaml` 17.12.1
- Packaging: Added `requests` 2.18.4
- Packaging: Removed `cffi`, will be installed with `xattr`
- Packaging: Removed `yappi`, useless on CI
- Packaging: Updated `Js2Py` from 0.58 to 0.59
- Packaging: Updated `faulthandler` from 3.0 to 3.1
- Packaging: Updated `psutil` from 5.4.3 to 5.4.4
- Packaging: Updated `pycryptodomex` from 3.5.1 to 3.6.1
- Packaging: Updated `pypac` from 0.4.0 to 0.8.1
- Packaging: Updated `pytest` from 3.3.2 to 3.5.1
- Packaging: Updated `python-dateutil` from 2.6.1 to 2.7.3
- Packaging: Updated `xattr` from 0.9.2 to 0.9.3
- Packaging: Upgraded `SIP` from 4.19.7 to 4.19.8
- Tracker: Removed the `Update` event

## Technical Changes

- Removed `AbstractOSIntegration.get_os_version()`
- Removed `AbstractOSIntegration.is_same_partition()`
- Removed `AbstractOSIntegration.os_version_above()`
- Removed `AbstractOSIntegration.os_version_below()`
- Removed `AbstractOSIntegration.register_contextual_menu()`
- Removed `AbstractOSIntegration.register_desktop_link()`
- Removed `AbstractOSIntegration.unregister_contextual_menu()`
- Removed `AbstractOSIntegration.unregister_desktop_link()`
- Added `AbstractOSIntegration.unwatch_folder()`
- Added `AbstractOSIntegration.watch_folder()`
- Removed `Application.app_updated()`
- Removed `Application.engineLogger`
- Removed `Application.icon_spin_timer`
- Removed `Application.icon_spin_count`
- Removed `Application.engineWidget`
- Removed `Application.get_cache_folder()`
- Removed `Application.get_mac_app()`
- Removed `Application.mainEngine`
- Removed `Application.restart()`
- Removed `Application.spin_transferring_icon()`
- Removed `Application.updated_version`
- Removed `BaseAutomationClient.is_addon_installed()`
- Added `CliHandler.ctx_access_online()`
- Moved `CliHandler.metadata(options)` to `ctx_edit_metadata(options)`
- Moved `CliHandler.share_link(file_path)` to `ctx_copy_share_link(options)`
- Removed `ConfigurationDAO.begin_transaction()`
- Removed `ConfigurationDAO.dispose_thread()`
- Removed `ConfigurationDAO.end_transaction()`
- Removed `ConsoleApplication.engineLogger`
- Removed `ConsoleApplication.mainEngine`
- Removed `ConsoleApplication.connect_engine_quit()`
- Removed `ConsoleApplication.quit_after_timeout()`
- Removed `ConsoleApplication.quit_if_sync_completed()`
- Removed `DarwinIntegration.register_contextual_menu()`
- Removed `DarwinIntegration.unregister_contextual_menu()`
- Added `DarwinIntegration.unwatch_folder()`
- Added `DarwinIntegration.watch_folder()`
- Added `edit=False` keyword to `Engine.get_metadata_url()`
- Removed `Engine.BATCH_MODE_DOWNLOAD`
- Removed `Engine.BATCH_MODE_FOLDER`
- Removed `Engine.BATCH_MODE_SYNC`
- Removed `Engine.BATCH_MODE_UPLOAD`
- Removed `Engine.complete_binder()`
- Removed `Engine.get_document_id()`
- Removed `Engine.get_last_sync()`
- Removed `Engine.get_next_file()`
- Removed `Engine.get_previous_file()`
- Added `Engine.local_folder_bs`
- Removed `Engine.resolve_with_duplicate()`
- Added `Engine.set_ui()`
- Changed `EngineDAO.__init__(self, db, state_factory=StateRow)` to `state_factory=None`
- Removed `EngineDAO.mark_descendants_remotely_deleted()`
- Removed `EngineDAO.mark_descendants_locally_created()`
- Changed `EngineDAO.update_remote_state()` `versionned` keyword argument to `versioned`
- Removed `EngineDAO.update_local_paths()`
- Removed `EngineLogger.logger`
- Removed `FileInfo.get_checkstate()`. Use `state` attribute instead.
- Removed `FileInfo.set_checkstate()`. Use `state` attribute instead.
- Removed `FileInfo.get_old_value()`. Use `old_state` attribute instead.
- Removed `FileInfo.get_parent()`
- Removed `FolderTreeview.set_client()`
- Removed `LocalClient.DEDUPED_BASENAME_PATTERN`
- Removed `LocalClient.root`
- Removed `LocalClient.check_writable()`
- Removed `LocalClient.duplicate_file()`
- Removed `LocalClient.duplication_enabled()`
- Removed `LocalClient.get_parent_ref()`
- Removed `LocalClient.is_inside()`
- Removed `LocalClient.unset_folder_icon()`
- Removed `LocalWatcher.get_windows_folder_scan_delay()`
- Removed `LocalWatcher.set_windows_folder_scan_delay()`
- Removed `LocalWatcher.get_windows_watchdog_event_buffer()`
- Removed `LocalWatcher.set_windows_watchdog_event_buffer()`
- Added `Manager.ctx_access_online()`
- Added `edit=False` keyword to `Manager.get_metadata_infos()`
- Moved `Manager.copy_share_link(file_path)` to `ctx_copy_share_link(file_path)`
- Moved `Manager.open_metadata_window(file_path, application=None)` to `ctx_edit_metadata(file_path)`
- Removed `Manager.check_version_updated()`
- Removed `Manager.find_exe_path()`
- Removed `Manager.get_cf_bundle_identifier()`
- Removed `Manager.get_engines_type()`
- Removed `Manager.get_updater()`. Use `updater` attribute instead.
- Removed `Manager.get_version()`. Use `version` property instead.
- Removed `Manager.get_version_finder()`
- Removed `Manager.list_server_bindings()`
- Removed `Manager.update_version()`
- Removed `Notification.add_replacement()`
- Removed `Notification.generate_uid()`
- Removed `Notification.is_volatile()`
- Removed `Notification.remove_replacement()`
- Removed `Notification.trigger()`
- Removed `Options.quit_timeout`
- Removed `Options.stop_on_error`
- Removed `Options.ui`
- Removed `Processor.path_locks()`
- Removed `QueueManager.init_queue()`
- Removed `RemoteDocumentClient.check_writable()`
- Removed `RemoteDocumentClient.set_property()`
- Removed `RemoteDocumentClient.get_parent()`
- Removed `RemoteFileSystemClient.can_move()`
- Removed `RemoteFileSystemClient.check_writable()`
- Removed `RemoteFileSystemClient.get_method()`
- Removed `RemoteWatcher.testing`
- Removed `RestAPIClient.get_acls()`
- Removed `StatusTreeview.filter_sync`
- Removed `WebConflictsApi.resolve_with_duplicate()`
- Removed `WebDriveApi.file_dialog_dir`
- Removed `WebDriveApi.get_last_url()`
- Removed `WebDriveApi.get_timestamp_from_sqlite()`
- Removed `WebModal.remove_button()`
- Removed `WindowsIntegration.__init__()`
- Removed `WindowsIntegration.get_key_bases()`
- Removed `WindowsIntegration.get_menu_entries()`
- Removed `WindowsIntegration.is_same_partition()`
- Removed `WindowsIntegration.register_contextual_menu()`
- Removed `WindowsIntegration.register_protocol_handlers()`
- Removed `WindowsIntegration.register_startup()`
- Removed `WindowsIntegration.unregister_contextual_menu()`
- Removed `WindowsIntegration.unregister_protocol_handlers()`
- Removed `WindowsIntegration.unregister_startup()`
- Removed `SimpleApplication.get_resource_dir()`. Use utils.py::`find_resource()` instead.
- Added `Translator.translations()`
- Added `WebDriveAPI.get_translations()`
- Removed `WebDriveAPI.get_appname()`
- Moved commandline.py:`dumpstacks()` to \_\_main__.py
- Moved commandline.py:`win32_unicode_argv()` to \_\_main__.py
- Removed commandline.py:`DEFAULT_NX_DRIVE_FOLDER`
- Removed commandline.py:`GET_CTL_MAX_NB_TRIES`
- Removed commandline.py:`GET_CTL_SLEEP_DURATION`
- Removed client/common.py::`DuplicationError()`
- Added constants.py::`BUNDLE_IDENTIFIER`
- Removed engine/engine.py::`EngineLogger()`
- Moved gui/resources.py::`find_icon()` to utils.py
- Removed gui/folder_treeview.py::`DocClient()`
- Added options.py::`server_updater()`
- Moved osi/\_\_init__.py::`parse_edit_protocol()` to utils.py
- Moved osi/\_\_init__.py::`parse_protocol_url()` to utils.py
- Removed osi/\_\_init__.py::`NXDRIVE_EDIT_URL_PREFIX`
- Removed osi/\_\_init__.py::`NXDRIVE_EDIT_URL_PATTERN_1`
- Removed osi/\_\_init__.py::`NXDRIVE_EDIT_URL_PATTERN_2`
- Removed osi/darwin/darwin.py::`RightClickService()`
- Removed osi/darwin/darwin.py::`serviceSelector()`
- Added updater package
- Removed updater.py
- Added utils.py::`version_between()`
- Added utils.py::`version_le()`
- Removed utils.py::`NUXEO_DRIVE_FOLDER_NAME`
- Removed utils.py::`ServerLoader()`
- Changed utils.py::`find_resource_dir(directory, default_path)` to `find_resource(folder, filename)`
- Moved utils.py::`default_nuxeo_drive_folder()` to `Manager.get_default_nuxeo_drive_folder()`
- Removed wui/conflicts.py::`WebConflictsDialog()`
- Removed wui/modal.py
